Attribute VB_Name = "Deklarationen"

Public AdressenOK As Integer             'True wenn alle Adressen okay
Attribute AdressenOK.VB_VarDescription = "True wenn alle Adressen okay"
Public ConfigOK As Boolean               'Wahr wenn das Einlesen der Config.dat okay war
Public FRAdresse As Integer              'Kleinste Adresse einer Fahrreglerkarte
Public AnzahlFR As Integer               'Anzahl der Fahrregler (nicht der Karten)
Attribute AnzahlFR.VB_VarDescription = "Anzahl der Fahrregler (nicht der Karten)"

Public Const ConfigBloecke As Integer = 100 'Maximale Anzahl der mglichen Blcke
Public Const ConfigGleise As Integer = 15   'Maximale Anzahl mglicher Gleise in den Blcken

Public Kalt As Integer                   'Anhebung der Minimal-Fahrstufe wenn Loks kalt
Public Const MaxStufe As Integer = 30    'Maximale Anzahl Fahrstufen
Public Kreise As Integer                 'Anzahl Kreise, vorerst noch ungenutzt

Public Kurzschluss As Integer            'Wahr wenn ein Kurzschluss aufgetreten ist
'Public MaxAdresse As Integer             '????
Public MaxBloecke As Integer             'tatschliche Anzahl der Blcke
Public MaxFr As Integer                  'Anzahl der tatschlich vorhandenen Fahrregler
Public Const MaxFS As Integer = 100      'Anzahl maximal mglicher Fahrstraen
Public WAdresse As Integer               'kleinste Adresse einer Weichen-karte
Public Signaladresse As Integer          'kleinste Adresse einer Signal-karte
Public MaxSignal As Integer              'Anzahl der tatschlich vorhandenen Signale (Licht- und Form-)
Public MaxLichtSignal As Integer         'Anzahl der tatschlich vorhandenen Lichtsignale
Public AnzahlSignale As Integer          'wird in Konfig_test gebraucht
Public MaxWeichen As Integer             'Anzahl maximal mglicher Weichen
Public AnzahlWeichen As Integer          'wird in Konfig_test gebraucht
Public Const MaxWInFS As Integer = 10    'Anzahl maximal mglicher Weichen in einer Fahrstrae
Public MinAdresseWK As Integer           'Kleinste Adresse einer Weichenkarte

Public NotBetrieb As Integer             'Wahr wenn diverse Prfungen ausgeschaltet
Public Oberleitung As Integer            'Wahr wenn Oberleitungsprfung eingeschaltet
Public Programmende As Integer           'Zustandsvariable des Programms:
                                         '     0 = Normalbetrieb
                                         '     1 = Betrieb angehalten
                                         '     2 = Betrieb normal einstellen
Public Stillstand As Integer             'Zustandsvariable des Programms, gehrt zu Programmende
Public MinBlockLaenge As Integer         'Minimum aller Block(x).MaxLaenge = lngster erlaubter Zug

Public SteuerungAktiv As Integer         '???? Funktioniert zumindest beim LPT-Anschlu nicht
Public UeTemp As Integer                 'Wahr wenn bertemperatur aufgetreten ist

Public WZaehler As Integer               'Weichenzhler, wenn 0 dann alle Weichen geschaltet
Public ZugLaenge As Integer              'Maximale Zuglnge????
Public Wartezeit As Integer              'Wartezeit zwischen Signal "Grn" und Abfahrt
Public BelegungAbgefragt As Boolean      'Kennzeichen ob Gleis-Belegung schon abgefragt
Attribute BelegungAbgefragt.VB_VarDescription = "Kennzeichen ob Gleis-Belegung schon abgefragt"

Type Bloecke                             'Daten zu einem Block
    BlockNr        As Integer            'Nummer des Blocks, eigentlich redundant da im Index
    Maxgleise      As Integer            'Maximale Anzahl Gleise in einem Block
    VorBlock       As Integer            'Nummer des vorhergehenden Blocks
    Folgeblock     As Integer            'Nummer des folgenden Blocks
    Modus          As Integer            'wenn Wahr dann Einfahrt in einen Block mit halber Geschwindigkeit
                                         'sonst Einfahrt mit Smax
    Einfahrt       As Integer            '0 wenn keine Einfahrt, sonst Nummer des Gleises, aus dem der Zug
                                         'im Vor-Block kommt
    Ausfahrt       As Integer            '0 wenn keine Ausfahrt, sonst Nummer des Gleises in das der Zug fahren soll
    Betrieb        As Integer            'Betriebsart (Hand, Automatik,...)
                                         '0 = Handbetrieb
                                         '1 = Automatik sequentiell erst in Gleis 1, dann 2, 3 usw.
                                         '2 = Automatik Zufall
                                         '3 = Automatik auf krzest-mgliches Gleis
    MaxLaenge      As Integer            'Lnge des lngsten Gleises in dem Block
    LEinfahrt      As Integer            'Nummer des Gleises, in das die letzte Einfahrt geschaltet war
    LAusfahrt      As Integer            'Nummer des Gleises, in das die nchste Ausfahrt zu schalten ist
    Zeitkontrolle  As Integer            'Multiplikator fr Wartezeit
    Durchfahrgleis As Integer            'Nummer des Gleises das ein Durchfahrgleis ist (nur fr Gterzge)
    Oberleitung    As Boolean            'Wahr wenn Oberleitung in dem Block, sehr fragwrdig ????
End Type
Public Block(100) As Bloecke
Attribute Block.VB_VarDescription = "Array mit 100 ""Bloecke"" fr alle Blcke"

Type Zuege                               'Daten zu einem Zug
    ZugNr       As Integer               'Nummer des Zuges
    Lok         As String * 20           'Name des Zuges
    Smin        As Integer               'minimale Fahrstufe
    Smax        As Integer               'maximale Fahrstufe
    Shalb       As Integer               'Langsam-Fahrstufe
    Beschleunigung  As Integer           'Wert fr Beschleunigung, minimal 1, maximal 20 (Schnell)
    Vmax        As Integer               'Geschwindigkeit in cm/s bei Smax
    Sist        As Integer               'aktuelle Fahrstufe eines Zuges
    Ssoll       As Integer               'Soll-Fahrstufe eines Zuges
    Ssollalt    As Integer               'Letzte Soll-Fahrstufe eines Zuges
    Zeit        As Single                'frheste Abfahrtzeit eines Zuges
    Intervall   As Single                'Abstand zweier Geschwindigkeistnderungen
                                         'wird aus Beschleunigung oder aus Lnge der
                                         'Bremsabschnitte errechnet
    ZugLaenge   As Integer               'Lnge des Zuges in cm
    Vorhanden   As Integer               'Wahr wenn der Zug schon auf der Anlage steht
    ELok        As Integer               'wahr wenn es eine E-Lok ist
    Gattung     As Integer               'wahr wenn es sich um einen Gterzug handelt
                                         'Widerspruch zu DatenModell.doc?????
    Aufenthalt  As Integer               'Wartezeit-Faktor fr einen Zug, 0 bis 180 Sekunden
                                         'tatschlicher Aufenthalt wird durch Multiplikation
                                         'mit Faktor des Blocks ermittelt
End Type
Public Zug(1 To 400) As Zuege
Public Const MaxZuege As Integer = 400   'Anzahl maximal mglicher Zge

Type Gleise                              'Daten zu einem Gleis
    BlockNr     As Integer               'Block-Nummer
    GleisNr     As Integer               'Gleis-Nummer
    Bezeichnung As String * 20           'Bezeichnung
    Zugindex    As Integer               'gibt an welcher Zug auf dem Gleis steht, wenn leer dann 0
    A1          As Boolean               'false wenn erster Fahrabschnitt leer, sonst true
    A2          As Boolean               'false wenn zweiter Fahrabschnitt leer, sonst true
    A3          As Boolean               'false wenn Bremsabschnitt leer, sonst true
    A4          As Boolean               'false wenn Haltabschnitt leer, sonst true
                                         'eventuell in Boolean ndern!
    L1          As Integer               'Lnge in cm des ersten Fahrabschnitts
    L2          As Integer               'Lnge in cm des zweiten Fahrabschnitts
    L3          As Integer               'Lnge in cm des Bremsabschnitts
    L4          As Integer               'Lnge in cm des Haltabschnitts
    BSM         As Integer               '0 bei Streckengleisen, sonst Mitte des Bahnsteigs in cm vom Beginn des Gleises
    Belegt      As Integer               'gibt an, welchen Abschnitt ein Zug im Gleis erreicht hat,
                                         '0 fr leer, sonst 1 fr A1, bis 4 fr A4
    Signal      As Integer               'Angeforderte Signalstellung (nicht Anzeige),
                                         '0 fr Halt, 1 fr langsame Fahrt, 2 fr freie Fahrt
    FoBlo       As Integer               'Kennzeichnet in welches Gleis des Folgeblocks der Zugindex fortgeschrieben wurde
                                         '0 fr noch nicht weitergeschrieben, 1 bis n fr Gleis in das fortgeschrieben wurde
    VorBlo      As Integer               'Kennzeichnet welches Gleis des vorhergehenden Blocks zu lschen ist
                                         '0 fr gelscht,1 bis n enthlt zu lschendes Gleis des vorherigen Blocks
    Korrektur   As Integer               'Plus/Minus Korrektur der Fahrstufen fr Steigungen oder Gefllestrecken
    Verlassen   As Boolean               'Wahr wenn der Zug den Block schon verlassen hat, dann bestimmt der nchste Block
                                         'die Fahrgeschwindigkeit
    FR          As Integer               'Nummer des Fahrreglers, der das Gleis steuert
    HP          As Integer               'Nummer des Abschnitts im Bahnhof an dem der Zug anhalten soll (2 bis 4)
    BS          As Integer               'Lnge der Bremsstrecke, Summe der Lnge der Abschnitte, an denen nicht gehalten wird
    Einfahrt    As Integer               'Nummer der Fahrstrasse, die zur Einfahrt in dieses Gleis geschaltet werden muss
                                         '0 (wenn nichts zu schalten ist) bis MaxFS
    Ausfahrt    As Integer               'Nummer der Fahrstrasse, die zur Ausfahrt aus diesem Gleis geschaltet werden muss
    Freigabe    As Integer               'Hhe der 'Belegt'-Variable, bei der der vorhergehende Block freigegeben werden kann (2 bis 4)
    Laenge      As Integer               'Summe aus L1, L2 und L3, 1 bis n cm
    NrSignal    As Integer               'Nummer des Signals an dem Block, 0 bis n
    Darstellung As Integer               'Nummer des Kstchens, in dem das Gleis im Fahrbetrieb-Dialog angezeigt werden soll
    Oberleitung As Integer               'wahr wenn Oberleitung vorhanden fr E-Loks
    Durchfahr   As Integer               'wahr wenn Durchfahrgleis im Bahnhof, eigentlich redundant da in Block-Daten die Gleis-Nummer steht
    Abfahrt     As Single                'Frheste Abfahrtzeit, abhngig vom Zug
    Gesperrt    As Integer               'wahr wenn Gleis vorbergehend fr Ein- und Ausfahrt gesperrt
'   LBelegung   As Integer               'wozu sollte das gut sein?????
End Type
Public Gleis(1 To ConfigBloecke, 1 To ConfigGleise) As Gleise

Type Zugindex                      'in Tabzugindex wird eingelesen wo beim letzten Mal welcher Zug stand
    BlockNr As Integer             'da das nicht jedes Mal gleich sein muss, muss eine temporre
    GleisNr As Integer             'Tabelle her
    ZugIndexNr As Integer
End Type
Public TabZugIndex(1 To ConfigBloecke, 1 To ConfigGleise) As Zugindex

Type Darstellungstyp               'in Darstellung wird abgelegt, auf welchen Block und welches Gleis
    Block As Integer               'sich ein Symbol bezieht
    Gleis As Integer
    Anzeigen As Boolean
End Type
Public Darstellung(1 To 80) As Darstellungstyp

Type FR                            'in den ersten vier Feldern wird abgelegt, ob der Abschnitt belegt ist
    Fahr1 As Boolean               'Belegung des ersten Fahrabschnitts, diese Felder werden nur im Form Frm_Fahrregler ausgewertet!
    Fahr2 As Boolean               'Belegung des zweiten Fahrabschnitts
    Brems As Boolean               'Belegung des Bremsabschnitts
    Halt As Boolean                'Belegung des Halt-Abschnitts
    FS As Integer                  'Fahrstufe des Fahrreglers (0-30!)
    FS_alt As Integer              'letzte ausgegebene Fahrstufe
    Block As Integer               'in Block und Gleis wird abgelegt, auf welches Gleis der Fahrregler wirkt
    Gleis As Integer               'damit dort der Zustand eingetragen werden kann
End Type
Public FR(0 To 150) As FR       'Name beisst sich eventuell mit gleichnamiger Variable in Datenverarbeitung.bas !?!

Public Karten(1 To 29) As Integer  'hierin werden die Karten-Typen abgelegt, 0 = nicht vorhanden
                                   '1  bis 15: Fahrregler,    2 = zweifach-FR,          4 = Vierfach-FR
                                   '16 bis 23: Weichenkarten, 2 = alte Weichenkarte,    4 = neue WK
                                   '24 bis 29: Signalkarten,  2 = Standard-Signalkarte, 4 = serielle Signalkarte

Type WWarten                       'hierin werden die zu schaltenden Weichen abgelegt, die Warteschleife wird dann mit
    Adresse As Integer                'jeweils ca. 0,5 Sekunden Abstand abgearbeitet
    Ausgabewert As Integer
End Type
Public WWarten(1 To 100) As WWarten

'Deklarationen fr Abspielen von Sounds
Public Declare Function sndPlaySound Lib "winmm.dll" _
Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public nret As Long

'Variablen fr Messagebox definieren
Public Mldg As String
Public Stil As Integer
Public Titel As String
Public Hilfe As String
Public ktxt As Integer
Public AntwortMsgbox As Long 'AntwortMsgbox = MsgBox(Mldg, Stil, Titel, Hilfe, ktxt)   ' Meldung anzeigen.
Attribute AntwortMsgbox.VB_VarDescription = "Aufruf einer Messagebox: AntwortMsgbox = MsgBox(Mldg, Stil, Titel, Hilfe, ktxt)"

'Ergebnis der Plausiprfungen
Public PlausiOK As Boolean

Type SG                           'hierin wird abgelegt, auf welches Gleis etc ein Signal wirkt
    Block As Integer
    Gleis As Integer
    LetzterWert As Integer        'seine letzte Stellung
    Anzeige As Integer            'seine aktuelle Stellung
    Zeit As Single                'wann es geschaltet werden soll
End Type
Public Sig(1 To 192) As SG
Type Signaldaten                  'hierin wird der aktuelle und der letzte Wert pro
    Wert As Integer               'Adresse fr Signale abgelegt
    WertAlt As Integer            'damit man steuern kann, dass nur genderte Werte ausgegeben werden
End Type
Public Signalstellung(0 To 255) As Signaldaten
Type Fahrstrassen                 'hierin werden die Weichen zu einer Fahrstrasse abgelegt
    FSNr    As Integer
    FSName  As String * 30
    WeicheNr As Integer
    Stellung As Integer
End Type
Public FS(MaxFS, MaxWInFS) As Fahrstrassen

Type Block_Liste
    Block As Integer
    Gleis As Integer
    ZugNr As Integer
End Type

Public Const Weiss As Long = 16777215
Public Const Rot As Long = 255
Public Const Gelb As Long = 65535
Public Programm As String         'In welchem programm befinden wir uns? Wird in Start-Form z. B. auf "GMT" gesetzt


'Deklarationen fr Grafik-Operationen:
Public Declare Function BitBlt Lib "Gdi32" (ByVal _
       NachHdc As Long, ByVal X As Long, ByVal _
       Y As Long, ByVal w As Long, ByVal h As Long, ByVal _
       vonHdc As Long, ByVal vonX As Long, ByVal _
       vonY As Long, ByVal Modus As Long) As Long


Public Const BIT_COPY As Long = &HCC0020

'Tipp von ActiveVB zum Erkennen der Bildschirmauflsung
'Mail: Tipps@ActiveVB.de
'berarbeitet von Florian Rittmeier (Florian@ActiveVB.de) und Jochen Wierum (JoWi@ActiveVB.de)
Public Declare Function GetDesktopWindow Lib "user32" () As Long

Public Declare Function GetWindowRect Lib "user32" ( _
    ByVal hwnd As Long, _
    lpRect As RECT) _
    As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Dhwnd As Long
Public R As RECT

Public PortNr As Integer
Public DatenEingelesen As Integer 'im Testprogramm eingelesene Daten
Public Nothalt As Integer
Public Anzeige_neu As Boolean 'wird im Testprogramm gebraucht wenn sich was an der Anzeige gendert hat
Public Eingangszeile As String 'Im Testprogramm verwandt zur Aufname einer Gleisbesetztmeldungszeile
Public IF_Antwort As Boolean 'Wahr wenn das Interface die richtige Antwort gesendet hatte
Public ResetAusgeloest As Boolean 'nderung 05.12.2011 schreibt erneut auf Fahrregler nach Reset
